---
apiVersion: apiextensions.k8s.io/v1
kind: CustomResourceDefinition
metadata:
  annotations:
    controller-gen.kubebuilder.io/version: v0.17.0
  name: bmhdatas.network.kanod.io
spec:
  group: network.kanod.io
  names:
    kind: BmhData
    listKind: BmhDataList
    plural: bmhdatas
    singular: bmhdata
  scope: Namespaced
  versions:
  - name: v1beta1
    schema:
      openAPIV3Schema:
        description: BmhData is the Schema for the bmhdatas API
        properties:
          apiVersion:
            description: |-
              APIVersion defines the versioned schema of this representation of an object.
              Servers should convert recognized schemas to the latest internal value, and
              may reject unrecognized values.
              More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#resources
            type: string
          kind:
            description: |-
              Kind is a string value representing the REST resource this object represents.
              Servers may infer this from the endpoint the client submits requests to.
              Cannot be updated.
              In CamelCase.
              More info: https://git.k8s.io/community/contributors/devel/sig-architecture/api-conventions.md#types-kinds
            type: string
          metadata:
            type: object
          spec:
            description: BmhDataSpec defines the desired state of BmhData
            properties:
              dnsServersFromIPPool:
                description: DnsServersFromIPPool retrieves dns associated to ippools
                items:
                  properties:
                    apiGroup:
                      description: Group of the IPPool
                      type: string
                    key:
                      description: Key is the key of the element in the templates
                        or in meta-data
                      type: string
                    kind:
                      description: Kind of the IPPool
                      type: string
                    name:
                      description: Name of the IPPool used
                      type: string
                  required:
                  - apiGroup
                  - key
                  - kind
                  - name
                  type: object
                type: array
              fromAnnotations:
                description: FromLabels associate keys to values of some labels in
                  the BaremetalHost
                items:
                  properties:
                    annotation:
                      description: Annotation is the name of the label on the BareMetalHost
                      type: string
                    key:
                      description: Key is the name of the element in the templates
                        or in meta-data
                      type: string
                  required:
                  - annotation
                  - key
                  type: object
                type: array
              fromLabels:
                description: FromLabels associate keys to values of some labels in
                  the BaremetalHost
                items:
                  properties:
                    key:
                      description: Key is the name of the element in the templates
                        or in meta-data
                      type: string
                    label:
                      description: Label is the name of the label on the BareMetalHost
                      type: string
                  required:
                  - key
                  - label
                  type: object
                type: array
              gatewaysFromIPPool:
                description: GatewaysFromIPPool retrieves gateway associated to ippools
                items:
                  properties:
                    apiGroup:
                      description: Group of the IPPool
                      type: string
                    key:
                      description: Key is the key of the element in the templates
                        or in meta-data
                      type: string
                    kind:
                      description: Kind of the IPPool
                      type: string
                    name:
                      description: Name of the IPPool used
                      type: string
                  required:
                  - apiGroup
                  - key
                  - kind
                  - name
                  type: object
                type: array
              generateMetadata:
                description: GenerateMetadata indicates which secrets to generate
                  and link
                type: boolean
              ipAddressesFromIPPool:
                description: |-
                  IpAddressesFromIPPool is a list of addresses generated for each instance
                  of the template.
                items:
                  properties:
                    apiGroup:
                      description: Group of the IPPool
                      type: string
                    key:
                      description: Key is the key of the element in the templates
                        or in meta-data
                      type: string
                    kind:
                      description: Kind of the IPPool
                      type: string
                    name:
                      description: Name of the IPPool used
                      type: string
                  required:
                  - apiGroup
                  - key
                  - kind
                  - name
                  type: object
                type: array
              networkData:
                description: |-
                  NetworkData is the name of an optional secret containing a go template
                  definition of the network data of the host.
                type: string
              prefixesFromIPPool:
                description: PrefixesFromIPPool retrieves the prefix of the ippools
                items:
                  properties:
                    apiGroup:
                      description: Group of the IPPool
                      type: string
                    key:
                      description: Key is the key of the element in the templates
                        or in meta-data
                      type: string
                    kind:
                      description: Kind of the IPPool
                      type: string
                    name:
                      description: Name of the IPPool used
                      type: string
                  required:
                  - apiGroup
                  - key
                  - kind
                  - name
                  type: object
                type: array
              preprovisioningNetwork:
                description: |-
                  PreprovisioningNetworkTemplate is the name of a secret containing a go
                  template definition of the preprovisioning network configuration
                  in Glean format at the key template
                type: string
              strings:
                description: Strings associate keys to fixed values
                items:
                  properties:
                    key:
                      description: Key is the name of the element in the templates
                        or in meta-data
                      type: string
                    value:
                      description: Value is the fixed value associated
                      type: string
                  required:
                  - key
                  - value
                  type: object
                type: array
              userData:
                description: |-
                  UserData is the name of an optional secret containing a go template
                  definition of the user data of the host.
                type: string
            type: object
          status:
            description: BmhDataStatus defines the observed state of BmhData
            type: object
        type: object
    served: true
    storage: true
    subresources:
      status: {}
